"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeKbonePluginConfig = exports.getPluginKboneSubpackage = exports.getKbonePluginEntry = exports.installKbonePlugin = exports.getPluginType = exports.installMpPlugin = void 0;
const fs = __importStar(require("fs-extra"));
const path = __importStar(require("path"));
const mp_1 = require("../../util/mp");
function installMpPlugin(appBuildDir, plugins) {
    return __awaiter(this, void 0, void 0, function* () {
        return Promise.all(plugins
            .filter(item => item.type === 'mp')
            .map((plugin) => __awaiter(this, void 0, void 0, function* () {
            const pluginModule = plugin.module;
            const pluginNodeModuleDir = path.resolve(appBuildDir, 'node_modules', pluginModule);
            const pluginPkgJson = yield fs.readJson(path.join(pluginNodeModuleDir, 'package.json'));
            const { pluginName } = pluginPkgJson;
            const pluginNodeModuleSrcDir = path.resolve(pluginNodeModuleDir, pluginName);
            const mpBuildPluginDir = path.resolve(appBuildDir, pluginName);
            const mpBuildAppJsonPath = path.resolve(appBuildDir, 'app.json');
            const pluginAppJsonPath = path.resolve(pluginNodeModuleDir, 'app.json');
            console.log('安装 mp 插件', pluginModule, mpBuildPluginDir);
            yield fs.copy(pluginNodeModuleSrcDir, mpBuildPluginDir, {
                overwrite: true,
            });
            yield (0, mp_1.mergeSubPackages)(mpBuildAppJsonPath, pluginAppJsonPath);
        }))).catch(err => console.error(err));
    });
}
exports.installMpPlugin = installMpPlugin;
function getPluginType(appBuildDir, plugins) {
    return __awaiter(this, void 0, void 0, function* () {
        const pluginsWithType = [];
        for (const plugin of plugins) {
            const pluginName = plugin.name;
            const pkgPath = path.resolve(appBuildDir, `node_modules/@govcloud/${pluginName}/package.json`);
            const pkgJson = yield fs.readJson(pkgPath);
            pluginsWithType.push(Object.assign(Object.assign({}, plugin), { type: pkgJson.pluginType }));
        }
        return pluginsWithType;
    });
}
exports.getPluginType = getPluginType;
function installKbonePlugin(appBuildDir, plugins) {
    return __awaiter(this, void 0, void 0, function* () {
        return Promise.all(plugins
            .filter(item => item.type === 'kbone')
            .map((plugin) => __awaiter(this, void 0, void 0, function* () {
            const pluginName = plugin.name;
            const pluginPackage = `@govcloud/${pluginName}`;
            const pluginNodeModuleDir = path.resolve(appBuildDir, 'node_modules', pluginPackage);
            const pluginNodeModuleSrcDir = path.resolve(pluginNodeModuleDir, 'src');
            const mpBuildPluginDir = path.resolve(appBuildDir, 'src', pluginName);
            console.log('安装 kbone 插件', plugin.name);
            try {
                yield fs.copy(pluginNodeModuleSrcDir, mpBuildPluginDir, {
                    overwrite: true,
                });
            }
            catch (e) {
                console.error('安装插件失败', plugin.name, e);
            }
        })));
    });
}
exports.installKbonePlugin = installKbonePlugin;
function getKbonePluginEntry(appBuildDir, plugins) {
    return __awaiter(this, void 0, void 0, function* () {
        const entry = {};
        for (const plugin of plugins) {
            if (plugin.type === 'kbone') {
                const pluginName = plugin.name;
                const pluginDir = path.resolve(appBuildDir, 'src', pluginName);
                const pagesDir = path.resolve(pluginDir, 'pages');
                const dirs = yield fs.readdir(pagesDir);
                yield Promise.all(dirs.map((dir) => __awaiter(this, void 0, void 0, function* () {
                    const entryPath = path.resolve(pagesDir, dir, 'main.mp.jsx');
                    if (yield fs.pathExists(entryPath)) {
                        entry[`${pluginName}__${dir}`] = entryPath;
                    }
                })));
            }
        }
        return entry;
    });
}
exports.getKbonePluginEntry = getKbonePluginEntry;
function getPluginKboneSubpackage(appBuildDir, plugins) {
    return __awaiter(this, void 0, void 0, function* () {
        const subpackages = {};
        for (const plugin of plugins) {
            if (plugin.type === 'kbone') {
                const pluginName = plugin.name;
                const entrys = yield getKbonePluginEntry(appBuildDir, plugins);
                subpackages[pluginName] = Object.keys(entrys).filter(entryPath => entryPath.includes(pluginName));
            }
        }
        return subpackages;
    });
}
exports.getPluginKboneSubpackage = getPluginKboneSubpackage;
function mergeKbonePluginConfig(appBuildDir, plugins, mpConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        console.time('mergeKbonePluginConfig');
        for (const plugin of plugins) {
            const pluginName = plugin.name;
            const mpConfigPath = path.resolve(appBuildDir, `node_modules/@govcloud/${pluginName}/scripts/miniprogram.config.js`);
            const pluginMpConfig = require(mpConfigPath);
            const pluginAppConfig = pluginMpConfig.app;
            pluginMpConfig.generate.subpackages[pluginName].forEach((pluginPage) => {
                var _a;
                if (!mpConfig.pages)
                    mpConfig.pages = {};
                mpConfig.pages[pluginPage] = {
                    extra: Object.assign(Object.assign({}, pluginAppConfig), (_a = ((pluginMpConfig === null || pluginMpConfig === void 0 ? void 0 : pluginMpConfig.pages) || {})[pluginPage]) === null || _a === void 0 ? void 0 : _a.extra),
                };
            });
            return mpConfig;
        }
        console.timeEnd('mergeKbonePluginConfig');
    });
}
exports.mergeKbonePluginConfig = mergeKbonePluginConfig;
