import { ISchema, Schema } from '@formily/react-schema-renderer';
import { IFileCodeMap, IComponentsInfoMap, IComponentInputProps } from '../types/common';
import { IMaterialItem, IWeAppComponentInstance } from '../../weapps-core';
export declare type PromiseResult<T> = Promise<[null, T] | [Error, null]>;
export declare function promiseWrapper<T>(p: Promise<T>): PromiseResult<T>;
export declare function deepDealComponentSchemaJson(schema: IWeAppComponentInstance, dealFn: (currentSchema: IWeAppComponentInstance) => void): void;
export declare function getMetaInfoBySourceKey(sourceKey: string): {
    materialName?: undefined;
    name?: undefined;
    variableName?: undefined;
} | {
    materialName: string;
    name: string;
    variableName: string;
};
export declare function isArray(src: any): boolean;
export declare function isPlainObject(src: any): boolean;
export declare function deepDeal(src: any, reviver: (key: any, value: any, parent: any) => void): void;
export declare function simpleDeepClone<T>(data: any): T;
export declare function JsonToStringWithVariableName(copyJson: any, options: {
    EOL: boolean;
}): string;
export declare function deepDealSchema(sourceSchema: ISchema, deal: (schema: Schema, key: string) => void): ISchema;
export declare function getComponentsInfo(appBuildDir: string, dependencies: IMaterialItem[], fileCodeMap: IFileCodeMap): Promise<IComponentsInfoMap>;
export declare function getInputProps(componentsMetaMap: IComponentsInfoMap): IComponentInputProps;
export declare function getYyptConfigInfo(extraData: any): Promise<{
    yyptAppKey: any;
    reportUrl: any;
    stopReport: boolean;
}>;
export declare function writeLibCommonRes2file(gItem: any, codeDir: string): Promise<{}>;
export declare function getFileNameByUrl(fileUrl: string): string;
export declare function upperFirst(str: string): string;
export declare function camelcase(str: string, firstUpperCase?: boolean): string;
export declare function cleanVarName(name: string): string;
//# sourceMappingURL=common.d.ts.map