"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.postprocessDeployExtraJson = exports.postprocessProjectConfig = void 0;
const fs_extra_1 = __importStar(require("fs-extra"));
const lodash_1 = require("lodash");
const path_1 = __importDefault(require("path"));
function postprocessProjectConfig(projectJsonPath, data) {
    let projectJson = fs_extra_1.default.readJsonSync(projectJsonPath);
    fs_extra_1.default.writeJsonSync(projectJsonPath, (0, lodash_1.merge)(projectJson, data), { spaces: 2 });
}
exports.postprocessProjectConfig = postprocessProjectConfig;
function postprocessDeployExtraJson(projectPath, deployOptions) {
    let { targetMpAppId, mpAppId } = deployOptions;
    if (targetMpAppId !== mpAppId) {
        let projectJson = fs_extra_1.default.readJsonSync(path_1.default.resolve(projectPath, 'project.config.json'));
        const miniprogramRoot = (projectJson === null || projectJson === void 0 ? void 0 : projectJson.miniprogramRoot) || './';
        const extPaht = path_1.default.resolve(projectPath, miniprogramRoot, 'ext.json');
        const extJson = Object.assign(Object.assign({}, (fs_extra_1.default.existsSync(extPaht) ? (0, fs_extra_1.readJsonSync)(extPaht) : {})), { extEnable: true, extAppid: targetMpAppId, directCommit: true });
        fs_extra_1.default.writeFileSync(extPaht, JSON.stringify(extJson, null, 2));
    }
}
exports.postprocessDeployExtraJson = postprocessDeployExtraJson;
